#ifndef SELECTION_H
#define SELECTION_H

#include <QString>
#include <QList>
#include <QGraphicsScene>
#include <QItemSelectionModel>

#include "treeitem.h"

class BranchObj;
class FloatImageObj;
class MapCenterObj;
class LinkableMapObj;
class VymModel;


class Selection 
{
public:
	enum Type {Undefined,Branch,MapCenter,FloatImage};
	Selection ();
	~Selection();
	void setModel (VymModel *);
	void update();      
	bool select (LinkableMapObj*);
	bool select (const QString &);
	bool reselect ();
	void unselect ();
	bool isBlocked ();
	void block();
	void unblock();
	bool isEmpty();
//	uint count();
//	Type type();
//	LinkableMapObj * first();		// first in selection list
//	LinkableMapObj * single();		// NULL, if multiple selected
//	BranchObj* getBranch();
//	TreeItem* getBranchItem();		
//	QModelIndex getBranchIndex();	//!< Returns index of first selected branch or mapcenter
	FloatImageObj* getFloatImage();

	QString getSelectString();

private:
	QList <LinkableMapObj*> selectList;
	QList <LinkableMapObj*> lastSelectList;

	VymModel *model;

	QColor color;
	bool blocked;					//!< if true, no new selection possible
};

#endif

